#include "painter.h"
#include "spring.h"


Painter::Painter( QWidget *parent )
        : QWidget( parent )
{
    setMinimumSize( 500, 160 );

    quit = new QPushButton( tr("Quit") );
    connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );

    spring = new Spring( this );

    reset = new QPushButton( tr("Reset") );
    connect( reset, SIGNAL(clicked()), spring, SLOT( reset() ) );

    apply = new QPushButton( tr("Apply")  );
    connect( apply, SIGNAL(clicked()), spring, SLOT( apply() ) );

    remove = new QPushButton( tr("Remove")  );
    connect( remove, SIGNAL(clicked()), this, SLOT( doRemove() ) );
    connect( this, SIGNAL(sendRemove()), spring, SLOT( remove() ) );

    forceText = new QLabel(  );
    forceText->setText("Force value:");
    forceText->setAlignment( Qt::AlignCenter );

    forceValue = new QDoubleSpinBox( );
	forceValue->setDecimals( 1 );
	forceValue->setRange( 0.0, 1.2 );
	forceValue->setSingleStep( 0.1 );
    connect( forceValue, SIGNAL(valueChanged(double)), spring, SLOT( setForce(double) ) );
	
    QGridLayout *grid = new QGridLayout( ); //2x2, 5 pixel border
    grid->addWidget( spring, 0, 1 );
    // grid->setColumnStretch( 1, 10 );

	QBoxLayout *leftBox = new QBoxLayout ( QBoxLayout::TopToBottom );
	leftBox->addWidget( quit );
	leftBox->addWidget( reset );
	leftBox->addWidget( forceText );
	leftBox->addWidget( forceValue );
	leftBox->addWidget( apply );
	leftBox->addWidget( remove );
	leftBox->addStretch( );
	grid->addLayout( leftBox, 0, 0 );

	setLayout( grid );
}

