#include "painter.h"
#include "spring.h"


Painter::Painter( QWidget *parent )
        : QWidget( parent )
{
    setMinimumSize( 500, 160 );

    quit = new QPushButton( tr("Salir") );
    connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );

    spring = new Spring( this );

    reset = new QPushButton( tr("Inicializar") );
    connect( reset, SIGNAL(clicked()), this, SLOT( aquiInicia() ) );
    connect( this, SIGNAL(enviaInicio()), spring, SLOT( resetea() ) );

    apply = new QPushButton( tr("Aplicar")  );
    connect( apply, SIGNAL(clicked()), spring, SLOT( deforma() ) );

    remove = new QPushButton( tr("Quitar")  );
    connect( remove, SIGNAL(clicked()), this, SLOT( aquiQuitaFuerza() ) );
    connect( this, SIGNAL(sendRemove()), spring, SLOT( quitaFuerza() ) );

    forceText = new QLabel(  );
    forceText->setText("Fuerza:");
    forceText->setAlignment( Qt::AlignCenter );

    forceValue = new QDoubleSpinBox( );
	forceValue->setDecimals( 1 );
	forceValue->setRange( 0.0, 1.2 );
	forceValue->setSingleStep( 0.1 );
    connect( forceValue, SIGNAL(valueChanged(double)), spring, SLOT( poneFuerza(double) ) );
	
    textoAngulo = new QLabel(  );
    textoAngulo->setText("ngulo:");
    textoAngulo->setAlignment( Qt::AlignCenter );

    angulo = new QDoubleSpinBox( );
	angulo->setDecimals( 1 );
	angulo->setRange( -180.0, 180.0 );
	angulo->setSingleStep( 1.0 );
    connect( angulo, SIGNAL(valueChanged(double)), spring, SLOT( poneAngulo(double) ) );

    textoResorte = new QLabel(  );
    textoResorte->setText("Nodo:");
    textoResorte->setAlignment( Qt::AlignCenter );

    cualResorte = new QSpinBox( );
	cualResorte->setRange( 1, 3 );
    connect( cualResorte, SIGNAL(valueChanged(int)), spring, SLOT( escogeResorte(int) ) );

    QGridLayout *grid = new QGridLayout( ); //2x2, 5 pixel border
    grid->addWidget( spring, 0, 1 );
    // grid->setColumnStretch( 1, 10 );

	QBoxLayout *leftBox = new QBoxLayout ( QBoxLayout::TopToBottom );
	leftBox->addWidget( quit );
	leftBox->addWidget( reset );
	leftBox->addWidget( textoResorte );
	leftBox->addWidget( cualResorte );
	leftBox->addWidget( forceText );
	leftBox->addWidget( forceValue );
	leftBox->addWidget( textoAngulo );
	leftBox->addWidget( angulo );
	leftBox->addWidget( apply );
	leftBox->addWidget( remove );
	leftBox->addStretch( );
	grid->addLayout( leftBox, 0, 0 );

	setLayout( grid );
}

